SystemOrganization addCategory: #OneOfArray!

Object subclass: #OneOfArray
	instanceVariableNames: 'array selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OneOfArray'!

!OneOfArray classSide methodsFor: 'instance creation' stamp: 'hjo 9/6/2011 16:44'!
array: anArray selectionIndex: anInteger

	^self new array: anArray selectionIndex: anInteger! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:31'!
array
	^ array! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:31'!
array: anArray
	array := anArray! !

!OneOfArray methodsFor: 'initialize-release' stamp: 'hjo 9/6/2011 16:43'!
array: anArray selectionIndex: anInteger

	self assert: [anInteger between: 1 and:  anArray size ].
	array := anArray.
	selectionIndex := anInteger. 

	! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:33'!
isSelectingFirstOne

	^selectionIndex = 1! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:33'!
isSelectingLastOne

	^selectionIndex = array size! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:32'!
nextOne

	^array at: selectionIndex+1! !

!OneOfArray methodsFor: 'near selection' stamp: 'hjo 9/6/2011 16:41'!
nextToSelection 

	^array at: selectionIndex + 1! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:32'!
previousOne

	^array at: selectionIndex-1! !

!OneOfArray methodsFor: 'near selection' stamp: 'hjo 9/6/2011 16:41'!
previousToSelection 

	^array at: selectionIndex - 1! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:40'!
selectFirstOne 

	selectionIndex := 1! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:40'!
selectLastOne 

	selectionIndex := array size.! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:38'!
selectNextOne

	selectionIndex + 1 > array size ifTrue: [^false].
	selectionIndex := selectionIndex + 1.
	^true.! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:39'!
selectNextOneCyclically

	| success |
	success := self selectNextOne.
	success ifFalse: [ self selectFirstOne ].! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:38'!
selectPreviousOne

	selectionIndex - 1 < 1 ifTrue: [^false].
	selectionIndex := selectionIndex - 1.
	^true.! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:40'!
selectPreviousOneCyclically

	| success |
	success := self selectPreviousOne.
	success ifFalse: [ self selectLastOne ].! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:32'!
selectedOne

	^array at: selectionIndex! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:31'!
selectionIndex
	^ selectionIndex! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:42'!
selectionIndex: anInteger

	self assert: [ anInteger between: 1 and: array size ].
	selectionIndex := anInteger! !
